osl::eval::ml::CheckShadowPtype Class Reference

`#include <pin.h>`

## Public Types

enum | { ONE_DIM = PTYPE_SIZE * 5 , DIM = ONE_DIM * EvalStages }

## Public Member Functions

template<osl::Player Defense>
osl::MultiInt | evalOne (const NumEffectState &state)

## Static Public Member Functions

static void | setUp (const Weights &weights)
static MultiInt | eval (const NumEffectState &state)
template<Player King>
static MultiInt | evalOne (const NumEffectState &state)

## Static Public Attributes

static CArray< MultiInt, ONE_DIM > | table

## Detailed Description

Definition at line 90 of file pin.h.

## Member Enumeration Documentation

## anonymous enum

anonymous enum

Enumerator
ONE_DIM |
DIM |

Definition at line 93 of file pin.h.

## Member Function Documentation

## eval()

osl::MultiInt osl::eval::ml::CheckShadowPtype::eval | ( | const NumEffectState & | state | ) |

static

Definition at line 247 of file eval_pin.cc.

References evalOne().

Referenced by osl::eval::ml::OpenMidEndingEval::OpenMidEndingEval(), and osl::eval::ml::OpenMidEndingEval::updateSub().

## evalOne() [1/2]

template<osl::Player Defense>

osl::MultiInt osl::eval::ml::CheckShadowPtype::evalOne | ( | const NumEffectState & | state | ) |

Definition at line 206 of file eval_pin.cc.

References osl::alt(), osl::BLACK, osl::NumEffectState::checkShadow(), osl::NumEffectState::hasEffectByPtypeStrict(), osl::SimpleState::kingSquare(), osl::LANCE, osl::SimpleState::pieceOf(), osl::Piece::ptype(), osl::PTYPE_SIZE, osl::Piece::square(), table, osl::WHITE, osl::Square::x(), and osl::Square::y().

## evalOne() [2/2]

template<Player King>

MultiInt osl::eval::ml::CheckShadowPtype::evalOne | ( | const NumEffectState & | state | ) |

static

Referenced by eval().

## setUp()

void osl::eval::ml::CheckShadowPtype::setUp | ( | const Weights & | weights | ) |

static

Definition at line 195 of file eval_pin.cc.

References osl::NStages, ONE_DIM, table, and osl::eval::ml::Weights::value().

## Member Data Documentation

## table

osl::CArray< MultiInt, 80 > osl::eval::ml::CheckShadowPtype::table

static

Definition at line 102 of file pin.h.

Referenced by evalOne(), and setUp().

The documentation for this class was generated from the following files:

- pin.h
- eval_pin.cc